<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="fr">
<head>
<!-- Generated by javadoc (11.0.17) on Sun Jan 22 15:20:06 CET 2023 -->
<title>Grundy2RecPerdantes</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF8">
<meta name="dc.created" content="2023-01-22">
<link rel="stylesheet" type="text/css" href="stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="jquery/jquery-ui.min.css" title="Style">
<link rel="stylesheet" type="text/css" href="jquery-ui.overrides.css" title="Style">
<script type="text/javascript" src="script.js"></script>
<script type="text/javascript" src="jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="jquery/jquery-3.6.0.min.js"></script>
<script type="text/javascript" src="jquery/jquery-ui.min.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Grundy2RecPerdantes";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10,"i26":10,"i27":10,"i28":10,"i29":10,"i30":10,"i31":10,"i32":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "./";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="deprecated-list.html">Deprecated</a></li>
<li><a href="index-all.html">Index</a></li>
<li><a href="help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<h2 title="Class Grundy2RecPerdantes" class="title">Class Grundy2RecPerdantes</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>Grundy2RecPerdantes</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>class <span class="typeNameLabel">Grundy2RecPerdantes</span>
extends java.lang.Object</pre>
<div class="block">Grundy game</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<section>
<ul class="blockList">
<li class="blockList"><a id="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>(package private) long</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#cpt">cpt</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>(package private) java.util.ArrayList&lt;java.util.ArrayList&lt;java.lang.Integer&gt;&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#posPerdantes">posPerdantes</a></span></code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section>
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">Grundy2RecPerdantes</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section>
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#afficheJeu(int,java.util.ArrayList)">afficheJeu</a></span>&#8203;(int&nbsp;tour,
          java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</code></th>
<td class="colLast">
<div class="block">Method that displays matches</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#enlever(java.util.ArrayList,int,int)">enlever</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
       int&nbsp;ligne,
       int&nbsp;nb)</code></th>
<td class="colLast">
<div class="block">Divise en deux tas les alumettes d'une ligne de jeu (1 ligne = 1 tas)</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#estConnuePerdante(java.util.ArrayList)">estConnuePerdante</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</code></th>
<td class="colLast">
<div class="block">Determines whether the configuration is known as a loser in posPerdante</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#estGagnante(java.util.ArrayList)">estGagnante</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</code></th>
<td class="colLast">
<div class="block">Indicates whether the configuration wins.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#estPerdante(java.util.ArrayList)">estPerdante</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</code></th>
<td class="colLast">
<div class="block">RECURSIVE method that indicates whether the configuration (of the current game or trial set) loses</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#estPossible(java.util.ArrayList)">estPossible</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</code></th>
<td class="colLast">
<div class="block">Teste s'il est possible de séparer un des tas</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#identiques(java.util.ArrayList,java.util.ArrayList)">identiques</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;liste1,
          java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;liste2)</code></th>
<td class="colLast">
<div class="block">Method allowing do determine if two lists contan the same items</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#jouerGagnant(java.util.ArrayList)">jouerGagnant</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</code></th>
<td class="colLast">
<div class="block">Play the winning move if it exists</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>(package private) java.util.ArrayList&lt;java.lang.Integer&gt;</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#normalise(java.util.ArrayList)">normalise</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</code></th>
<td class="colLast">
<div class="block">method that copies an ArrayList</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#partie()">partie</a></span>()</code></th>
<td class="colLast">
<div class="block">Method that manages the game by creating the players 
 and the number of matche.</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>(package private) boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#partieTerminee(java.util.ArrayList)">partieTerminee</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</code></th>
<td class="colLast">
<div class="block">Method that checks after each turn that the game can or not continue</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>(package private) int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#premier(java.util.ArrayList,java.util.ArrayList)">premier</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
       java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeuEssai)</code></th>
<td class="colLast">
<div class="block">Crée une toute première configuration d'essai à partir du jeu</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#principal()">principal</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>(package private) int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#suivant(java.util.ArrayList,java.util.ArrayList,int)">suivant</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
       java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeuEssai,
       int&nbsp;ligne)</code></th>
<td class="colLast">
<div class="block">Génère la configuration d'essai suivante (c'est-à-dire UNE décomposition possible)</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testafficheJeu()">testafficheJeu</a></span>()</code></th>
<td class="colLast">
<div class="block">testing method affichePartie</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testCasAfficheJeu(int,java.util.ArrayList,java.lang.String)">testCasAfficheJeu</a></span>&#8203;(int&nbsp;tour,
                 java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                 java.lang.String&nbsp;result)</code></th>
<td class="colLast">
<div class="block">Test a call of affichePartie</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testCasEstConnuePerdante(java.util.ArrayList,boolean)">testCasEstConnuePerdante</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;copie,
                        boolean&nbsp;ret)</code></th>
<td class="colLast">
<div class="block">Method allowing to test several cases of estConnuePerdante method</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testCasIdentiques(java.util.ArrayList,java.util.ArrayList,boolean)">testCasIdentiques</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;liste1,
                 java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;liste2,
                 boolean&nbsp;ret)</code></th>
<td class="colLast">
<div class="block">Allows to test several cases of identiques</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testCasJouerGagnant(java.util.ArrayList,java.util.ArrayList,boolean)">testCasJouerGagnant</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                   java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;resJeu,
                   boolean&nbsp;res)</code></th>
<td class="colLast">
<div class="block">Test d'un cas de la méthode jouerGagnant()</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testCasNormalise(java.util.ArrayList,java.util.ArrayList)">testCasNormalise</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;result)</code></th>
<td class="colLast">
<div class="block">Method allowing to test several cases of normalise method</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testCasPartieTerminee(java.util.ArrayList,boolean)">testCasPartieTerminee</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                     boolean&nbsp;result)</code></th>
<td class="colLast">
<div class="block">Test a call of partieTerminer</div>
</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testCasPremier(java.util.ArrayList,int,java.util.ArrayList)">testCasPremier</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
              int&nbsp;ligne,
              java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;res)</code></th>
<td class="colLast">
<div class="block">Test un cas de la méthode testPremier</div>
</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testCasSuivant(java.util.ArrayList,java.util.ArrayList,int,java.util.ArrayList,int)">testCasSuivant</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
              java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeuEssai,
              int&nbsp;ligne,
              java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;resJeu,
              int&nbsp;resLigne)</code></th>
<td class="colLast">
<div class="block">Test un cas de la méthode suivant</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testEstConnuePerdante()">testEstConnuePerdante</a></span>()</code></th>
<td class="colLast">
<div class="block">Method allowing to test estConnuePerdante method</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testEstGagnanteEfficacite()">testEstGagnanteEfficacite</a></span>()</code></th>
<td class="colLast">
<div class="block">Efficiency testing method of estGagnante</div>
</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testIdentiques()">testIdentiques</a></span>()</code></th>
<td class="colLast">
<div class="block">Allows to test identiques</div>
</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testJouerGagnant()">testJouerGagnant</a></span>()</code></th>
<td class="colLast">
<div class="block">Tests succincts de la méthode joueurGagnant()</div>
</td>
</tr>
<tr id="i27" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testNormalise()">testNormalise</a></span>()</code></th>
<td class="colLast">
<div class="block">Method allowing to test normalise method</div>
</td>
</tr>
<tr id="i28" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testPartieTerminee()">testPartieTerminee</a></span>()</code></th>
<td class="colLast">
<div class="block">Tests the partieTerminer method</div>
</td>
</tr>
<tr id="i29" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testPremier()">testPremier</a></span>()</code></th>
<td class="colLast">
<div class="block">Tests succincts de la méthode premier()</div>
</td>
</tr>
<tr id="i30" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#testSuivant()">testSuivant</a></span>()</code></th>
<td class="colLast">
<div class="block">Tests succincts de la méthode suivant()</div>
</td>
</tr>
<tr id="i31" class="rowColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#untour(java.lang.String,java.util.ArrayList,int)">untour</a></span>&#8203;(java.lang.String&nbsp;joueur,
      java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
      int&nbsp;tour)</code></th>
<td class="colLast">
<div class="block">Method that spins a turn of the game for a given player</div>
</td>
</tr>
<tr id="i32" class="altColor">
<td class="colFirst"><code>(package private) void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#unTourOrdi(java.lang.String,java.util.ArrayList,int)">unTourOrdi</a></span>&#8203;(java.lang.String&nbsp;joueur,
          java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
          int&nbsp;tour)</code></th>
<td class="colLast">
<div class="block">Method that runs a round of the game for the computer</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<section>
<ul class="blockList">
<li class="blockList"><a id="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a id="cpt">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cpt</h4>
<pre>long cpt</pre>
</li>
</ul>
<a id="posPerdantes">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>posPerdantes</h4>
<pre>java.util.ArrayList&lt;java.util.ArrayList&lt;java.lang.Integer&gt;&gt; posPerdantes</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section>
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Grundy2RecPerdantes</h4>
<pre>Grundy2RecPerdantes()</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section>
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="principal()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>principal</h4>
<pre class="methodSignature">void&nbsp;principal()</pre>
</li>
</ul>
<a id="testEstGagnanteEfficacite()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testEstGagnanteEfficacite</h4>
<pre class="methodSignature">void&nbsp;testEstGagnanteEfficacite()</pre>
<div class="block">Efficiency testing method of estGagnante</div>
</li>
</ul>
<a id="partie()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>partie</h4>
<pre class="methodSignature">void&nbsp;partie()</pre>
<div class="block">Method that manages the game by creating the players 
 and the number of matche.</div>
</li>
</ul>
<a id="afficheJeu(int,java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>afficheJeu</h4>
<pre class="methodSignature">void&nbsp;afficheJeu&#8203;(int&nbsp;tour,
                java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</pre>
<div class="block">Method that displays matches</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tour</code> - Tour to which we are</dd>
<dd><code>jeu</code> - ArrayList filled with matches</dd>
</dl>
</li>
</ul>
<a id="partieTerminee(java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>partieTerminee</h4>
<pre class="methodSignature">boolean&nbsp;partieTerminee&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</pre>
<div class="block">Method that checks after each turn that the game can or not continue</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - ArrayList filled with matches</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>if the game is finish</dd>
</dl>
</li>
</ul>
<a id="untour(java.lang.String,java.util.ArrayList,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>untour</h4>
<pre class="methodSignature">void&nbsp;untour&#8203;(java.lang.String&nbsp;joueur,
            java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
            int&nbsp;tour)</pre>
<div class="block">Method that spins a turn of the game for a given player</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>joueur</code> - name of the player</dd>
<dd><code>jeu</code> - ArrayList filled with matches</dd>
<dd><code>tour</code> - Tour to which we are</dd>
</dl>
</li>
</ul>
<a id="unTourOrdi(java.lang.String,java.util.ArrayList,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>unTourOrdi</h4>
<pre class="methodSignature">void&nbsp;unTourOrdi&#8203;(java.lang.String&nbsp;joueur,
                java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                int&nbsp;tour)</pre>
<div class="block">Method that runs a round of the game for the computer</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>joueur</code> - name of the player</dd>
<dd><code>jeu</code> - ArrayList filled with matches</dd>
<dd><code>tour</code> - Tour to which we are</dd>
</dl>
</li>
</ul>
<a id="testafficheJeu()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testafficheJeu</h4>
<pre class="methodSignature">void&nbsp;testafficheJeu()</pre>
<div class="block">testing method affichePartie</div>
</li>
</ul>
<a id="testCasAfficheJeu(int,java.util.ArrayList,java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testCasAfficheJeu</h4>
<pre class="methodSignature">void&nbsp;testCasAfficheJeu&#8203;(int&nbsp;tour,
                       java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                       java.lang.String&nbsp;result)</pre>
<div class="block">Test a call of affichePartie</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>tour</code> - Tour to which we are</dd>
<dd><code>jeu</code> - ArrayList filled with matches</dd>
<dd><code>result</code> - expected Result</dd>
</dl>
</li>
</ul>
<a id="testPartieTerminee()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testPartieTerminee</h4>
<pre class="methodSignature">void&nbsp;testPartieTerminee()</pre>
<div class="block">Tests the partieTerminer method</div>
</li>
</ul>
<a id="testCasPartieTerminee(java.util.ArrayList,boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testCasPartieTerminee</h4>
<pre class="methodSignature">void&nbsp;testCasPartieTerminee&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                           boolean&nbsp;result)</pre>
<div class="block">Test a call of partieTerminer</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - ArrayList filled with matches</dd>
<dd><code>result</code> - expected Result</dd>
</dl>
</li>
</ul>
<a id="jouerGagnant(java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>jouerGagnant</h4>
<pre class="methodSignature">boolean&nbsp;jouerGagnant&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</pre>
<div class="block">Play the winning move if it exists</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - Game board</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>vrai If there is a winning move, false otherwise</dd>
</dl>
</li>
</ul>
<a id="estPerdante(java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>estPerdante</h4>
<pre class="methodSignature">boolean&nbsp;estPerdante&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</pre>
<div class="block">RECURSIVE method that indicates whether the configuration (of the current game or trial set) loses</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - Current game board (the state of the game at a certain point during the game)</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>vrai si la configuration (du jeu) est perdante, faux sinon</dd>
</dl>
</li>
</ul>
<a id="estGagnante(java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>estGagnante</h4>
<pre class="methodSignature">boolean&nbsp;estGagnante&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</pre>
<div class="block">Indicates whether the configuration wins.
 Method that simply calls "estPerdante".</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - board game</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>vrai si la configuration est gagnante, faux sinon</dd>
</dl>
</li>
</ul>
<a id="testJouerGagnant()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testJouerGagnant</h4>
<pre class="methodSignature">void&nbsp;testJouerGagnant()</pre>
<div class="block">Tests succincts de la méthode joueurGagnant()</div>
</li>
</ul>
<a id="testCasJouerGagnant(java.util.ArrayList,java.util.ArrayList,boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testCasJouerGagnant</h4>
<pre class="methodSignature">void&nbsp;testCasJouerGagnant&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                         java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;resJeu,
                         boolean&nbsp;res)</pre>
<div class="block">Test d'un cas de la méthode jouerGagnant()</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - le plateau de jeu</dd>
<dd><code>resJeu</code> - le plateau de jeu après avoir joué gagnant</dd>
<dd><code>res</code> - le résultat attendu par jouerGagnant</dd>
</dl>
</li>
</ul>
<a id="enlever(java.util.ArrayList,int,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>enlever</h4>
<pre class="methodSignature">void&nbsp;enlever&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
             int&nbsp;ligne,
             int&nbsp;nb)</pre>
<div class="block">Divise en deux tas les alumettes d'une ligne de jeu (1 ligne = 1 tas)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - tableau des alumettes par ligne</dd>
<dd><code>ligne</code> - ligne (tas) sur laquelle les alumettes doivent être séparées</dd>
<dd><code>nb</code> - nombre d'alumettes RETIREE de la ligne après séparation</dd>
</dl>
</li>
</ul>
<a id="estPossible(java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>estPossible</h4>
<pre class="methodSignature">boolean&nbsp;estPossible&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</pre>
<div class="block">Teste s'il est possible de séparer un des tas</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - plateau de jeu</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>vrai s'il existe au moins un tas de 3 allumettes ou plus, faux sinon</dd>
</dl>
</li>
</ul>
<a id="premier(java.util.ArrayList,java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>premier</h4>
<pre class="methodSignature">int&nbsp;premier&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
            java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeuEssai)</pre>
<div class="block">Crée une toute première configuration d'essai à partir du jeu</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - plateau de jeu</dd>
<dd><code>jeuEssai</code> - nouvelle configuration du jeu</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>le numéro du tas divisé en deux ou (-1) si il n'y a pas de tas d'au moins 3 allumettes</dd>
</dl>
</li>
</ul>
<a id="testPremier()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testPremier</h4>
<pre class="methodSignature">void&nbsp;testPremier()</pre>
<div class="block">Tests succincts de la méthode premier()</div>
</li>
</ul>
<a id="testCasPremier(java.util.ArrayList,int,java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testCasPremier</h4>
<pre class="methodSignature">void&nbsp;testCasPremier&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                    int&nbsp;ligne,
                    java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;res)</pre>
<div class="block">Test un cas de la méthode testPremier</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - le plateau de jeu</dd>
<dd><code>ligne</code> - le numéro du tas séparé en premier</dd>
<dd><code>res</code> - le plateau de jeu après une première séparation</dd>
</dl>
</li>
</ul>
<a id="suivant(java.util.ArrayList,java.util.ArrayList,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>suivant</h4>
<pre class="methodSignature">int&nbsp;suivant&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
            java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeuEssai,
            int&nbsp;ligne)</pre>
<div class="block">Génère la configuration d'essai suivante (c'est-à-dire UNE décomposition possible)</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - plateau de jeu</dd>
<dd><code>jeuEssai</code> - configuration d'essai du jeu après séparation</dd>
<dd><code>ligne</code> - le numéro du tas qui est le dernier à avoir été séparé</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>le numéro du tas divisé en deux pour la nouvelle configuration, -1 si plus aucune décomposition n'est possible</dd>
</dl>
</li>
</ul>
<a id="testSuivant()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testSuivant</h4>
<pre class="methodSignature">void&nbsp;testSuivant()</pre>
<div class="block">Tests succincts de la méthode suivant()</div>
</li>
</ul>
<a id="testCasSuivant(java.util.ArrayList,java.util.ArrayList,int,java.util.ArrayList,int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testCasSuivant</h4>
<pre class="methodSignature">void&nbsp;testCasSuivant&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                    java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeuEssai,
                    int&nbsp;ligne,
                    java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;resJeu,
                    int&nbsp;resLigne)</pre>
<div class="block">Test un cas de la méthode suivant</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - le plateau de jeu</dd>
<dd><code>jeuEssai</code> - le plateau de jeu obtenu après avoir séparé un tas</dd>
<dd><code>ligne</code> - le numéro du tas qui est le dernier à avoir été séparé</dd>
<dd><code>resJeu</code> - est le jeuEssai attendu après séparation</dd>
<dd><code>resLigne</code> - est le numéro attendu du tas qui est séparé</dd>
</dl>
</li>
</ul>
<a id="estConnuePerdante(java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>estConnuePerdante</h4>
<pre class="methodSignature">boolean&nbsp;estConnuePerdante&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</pre>
<div class="block">Determines whether the configuration is known as a loser in posPerdante</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - le plateau de jeu</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>vrai si le jeu est dans posPerdantes</dd>
</dl>
</li>
</ul>
<a id="normalise(java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>normalise</h4>
<pre class="methodSignature">java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;normalise&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu)</pre>
<div class="block">method that copies an ArrayList</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - game to copy</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the copy</dd>
</dl>
</li>
</ul>
<a id="identiques(java.util.ArrayList,java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>identiques</h4>
<pre class="methodSignature">boolean&nbsp;identiques&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;liste1,
                   java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;liste2)</pre>
<div class="block">Method allowing do determine if two lists contan the same items</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>liste1</code> - first list</dd>
<dd><code>liste2</code> - second list</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if lists are identical, false otherwise</dd>
</dl>
</li>
</ul>
<a id="testIdentiques()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testIdentiques</h4>
<pre class="methodSignature">void&nbsp;testIdentiques()</pre>
<div class="block">Allows to test identiques</div>
</li>
</ul>
<a id="testCasIdentiques(java.util.ArrayList,java.util.ArrayList,boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testCasIdentiques</h4>
<pre class="methodSignature">void&nbsp;testCasIdentiques&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;liste1,
                       java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;liste2,
                       boolean&nbsp;ret)</pre>
<div class="block">Allows to test several cases of identiques</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>liste1</code> - collection of items</dd>
<dd><code>liste2</code> - collection of loosing positions</dd>
<dd><code>ret</code> - boolean expected</dd>
</dl>
</li>
</ul>
<a id="testNormalise()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testNormalise</h4>
<pre class="methodSignature">void&nbsp;testNormalise()</pre>
<div class="block">Method allowing to test normalise method</div>
</li>
</ul>
<a id="testCasNormalise(java.util.ArrayList,java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testCasNormalise</h4>
<pre class="methodSignature">void&nbsp;testCasNormalise&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;jeu,
                      java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;result)</pre>
<div class="block">Method allowing to test several cases of normalise method</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>jeu</code> - game board</dd>
<dd><code>result</code> - list expected after normalise method</dd>
</dl>
</li>
</ul>
<a id="testEstConnuePerdante()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>testEstConnuePerdante</h4>
<pre class="methodSignature">void&nbsp;testEstConnuePerdante()</pre>
<div class="block">Method allowing to test estConnuePerdante method</div>
</li>
</ul>
<a id="testCasEstConnuePerdante(java.util.ArrayList,boolean)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>testCasEstConnuePerdante</h4>
<pre class="methodSignature">void&nbsp;testCasEstConnuePerdante&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;copie,
                              boolean&nbsp;ret)</pre>
<div class="block">Method allowing to test several cases of estConnuePerdante method</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>copie</code> - collection of integers items</dd>
<dd><code>ret</code> - boolean expected after method</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="deprecated-list.html">Deprecated</a></li>
<li><a href="index-all.html">Index</a></li>
<li><a href="help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
